local TICRATE = 35
local cannontargets = {}

addHook("NetVars", function(net)
    cannontargets = net(cannontargets)
end)

local function hostmod_cannon(p, ...)
    local target = string.lower(...)
	table.insert(cannontargets, target)
    CONS_Printf(p, "Added cannon target: "..target)
end
COM_AddCommand("hm_namefilter", hostmod_cannon, 1)

local hostmod_cannonmode = CV_RegisterVar({
    name = "hm_namefilter_mode",
    defaultvalue = "Kick",
    flags = CV_NETVAR,
    possiblevalue = {Print = 1, Kick = 2, Ban = 3}
})

local function doCannon(p)
	for k, v in ipairs(cannontargets)
		if string.find(p.name:lower(), v, 0, true) then
			if hostmod_cannonmode.value == 1 then
				print("Cannon would have affected "..p.name)
			elseif hostmod_cannonmode.value == 2 then
				COM_BufInsertText(server, 'kick "'..p.name..'" BANG')
			else
				COM_BufInsertText(server, 'ban "'..p.name..'" BANG')
			end
		end
	end
end

local intermissiontimer
addHook("ThinkFrame", function()
    if consoleplayer == server and leveltime % (TICRATE*5) == 0 then
        for p in players.iterate do
            doCannon(p)
        end
        intermissiontimer = 0
    end
end)

addHook("IntermissionThinker", function()
    if consoleplayer == server then
        intermissiontimer = intermissiontimer or 0
        intermissiontimer = $ + 1
        if intermissiontimer % (TICRATE*5) == 0 then
            for p in players.iterate do
                doCannon(p)
            end
        end
    end
end)