local hm_discord = CV_RegisterVar({
	name = "hm_discord",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})

local file
local init
local PATH_BASE = "discord"
local EXT_BASE = ".txt"
local PATH_IN = PATH_BASE + "-in" + EXT_BASE
local PATH_OUT
local blocked = {}
local RS_THINK, RS_VOTE, RS_INT = 1, 2, 3
local roundstatus = RS_THINK
local lastmapname = ""
local sendqueue = {}

local DFA_UNKNOWN, DFA_FUCKOFF, DFA_LETSFUCKINGGO = 1, 2, 3
local dofuckinganything = DFA_UNKNOWN

local pendname = ""
local pendcontent = ""

local function filewrite(str)
	if not hm_discord.value then return end
	if dofuckinganything != DFA_LETSFUCKINGGO then return end
	if replayplayback then return end
	if not file then print("HOW") return end
	file:write(str.."\n")
	file:flush()
end

local function playercount()
	local pc = 0
	for p in players.iterate
		pc = $ + 1
	end
	return pc
end

local function fileprint(str)
	if playercount() > 0 then filewrite(str) end
end

local function escapename(name)
	return name:gsub("*", "\\*")
end

addHook("ThinkFrame", function()
	if dofuckinganything == DFA_UNKNOWN then
		if server.jointime == 0 then
			dofuckinganything = DFA_LETSFUCKINGGO
		else
			dofuckinganything = DFA_FUCKOFF
		end
	end
	if not (hm_discord.value and dofuckinganything == DFA_LETSFUCKINGGO) then return end
	if not init then
		local seekname = true
		while seekname
			PATH_OUT = PATH_BASE + "-out-" + HM_Random() + EXT_BASE
			local f = io.open(PATH_OUT)
			if f != nil then io.close(f) else seekname = false end
		end
		file = io.open(PATH_OUT, "w+")
		file:write("\n")
		file:close()
		file = nil
		file = io.open(PATH_OUT, "a+")
		file:setvbuf("line")
		init = true
	end
	if leveltime == 1 and lastmapname != G_BuildMapName(gamemap) then
		fileprint('**Map is now '..G_BuildMapName(gamemap).." - "..hm_trim(mapheaderinfo[gamemap].lvlttl.." "..mapheaderinfo[gamemap].zonttl)..'**')
		lastmapname = G_BuildMapName(gamemap)
	end
end)

local function chatMsg(p, msgtype, target, msg)
    if msgtype == 0 then
        fileprint(("**%s**: %s"):format(escapename(p.name), msg))
    end
end
addHook("PlayerMsg", chatMsg)

local function hm__dn(p, ...)
	local toset = table.concat({...}, " ")
	pendname = toset
end
COM_AddCommand("hm__dn", hm__dn, 1)

local function hm__dc(p, ...)
	local toset = table.concat({...}, " ")
	pendcontent = $..toset
end
COM_AddCommand("hm__dc", hm__dc, 1)

local function hm__ds(p, ...)
	if pendname == "" then return end
	chatprint("\132<#"..pendname.."> \128"..pendcontent, true)
	pendname = ""
	pendcontent = ""
end
COM_AddCommand("hm__ds", hm__ds, 1)

local function getmessages()
	if not hm_discord.value then return end
	if replayplayback then return end
	for p in players.iterate
		if not p.HMDwarned then
			chatprintf(p, "\132*This server is linked to a Discord channel. Messages from Discord users will be marked with a blue #. Say hi!", 1)
			p.HMDwarned = true
			filewrite("**"..p.name.." joined the game.**")
		end
		if p.HMDlastname and (p.HMDlastname != p.name)
			filewrite("**"..escapename(p.HMDlastname).." renamed to "..escapename(p.name).."**")
		end
		p.HMDlastname = p.name
	end
	if dofuckinganything != DFA_LETSFUCKINGGO then return end
	if sendqueue[1] then
		COM_BufAddText(server, sendqueue[1])
		--print(sendqueue[1])
		local ind = 2
		repeat
			sendqueue[ind-1] = sendqueue[ind]
			ind = $ + 1
		until sendqueue[ind] == nil
		sendqueue[ind-1] = nil
	end
	if leveltime % (TICRATE*3) then return end
	local file = io.open(PATH_IN, "r")
	if not file then return end
	local line
	local name
	repeat 
		line = file:read()
		if line
			local args = {}
			for a in line:gmatch("%S+") do table.insert(args, a) end
			if args[1] == "NAME" then
				name = string.sub(line, #args[1] + #args[2] + 3)
			elseif args[1] == "CONTENT" then
				if not blocked[args[2]] then		
					table.insert(sendqueue, 'hm__dn "'..name..'"')
					local msgcontent = string.sub(line, #args[1] + #args[2] + 3)
					local bail = false
					repeat
						local substr = ""
						if #msgcontent >= 20 then
							substr = msgcontent:sub(1, 20)
						else
							substr = msgcontent
							bail = true
						end
						table.insert(sendqueue, 'hm__dc "'..substr..'"')
						if not bail then msgcontent = $:sub(21) end
					until bail
					table.insert(sendqueue, "hm__ds")
					filewrite("ACK "..args[2])
					blocked[args[2]] = true
				end
			end
		end
	until not line
	file:close()
end
addHook("ThinkFrame", getmessages)
addHook("IntermissionThinker", getmessages)
addHook("VoteThinker", getmessages)

addHook("PlayerQuit", function(p, reason)
	local reasons = {"Kicked", "broke ping limit", "Synch failure", "Connection timeout", "Banned", "Quit"}
	filewrite("**"..escapename(p.name).." left the game ("..reasons[reason]..")**")
end)

local function buildTimeString(p)
	if p.pflags & PF_TIMEOVER then return "NO CONTEST." end
	local x = p.realtime
	return ""..string.format("%02d", G_TicsToMinutes(x)).."' "..string.format("%02d", G_TicsToSeconds(x))..'" '..string.format("%02d", G_TicsToCentiseconds(x))
end

local function tryresults()
	if not hm_discord.value then return end
	if roundstatus != RS_THINK then return end
	local sortedplayers = {}
	local resultstring = "**Result - "..hm_trim(mapheaderinfo[gamemap].lvlttl.." "..mapheaderinfo[gamemap].zonttl).."**|||```"
	for p in players.iterate
		if p.spectator then continue end
		table.insert(sortedplayers, p)
	end
	table.sort(sortedplayers, function(a, b)
		if not ((a.pflags & PF_TIMEOVER) == (b.pflags & PF_TIMEOVER)) then
			return b.pflags & PF_TIMEOVER
		end
		if G_BattleGametype() then
			return a.marescore > b.marescore
		else
			return a.realtime < b.realtime
		end
	end)
	for _,p in ipairs(sortedplayers)
		if G_BattleGametype() then
			resultstring = $.."|||"..p.name.." - "..p.marescore
		else
			resultstring = $.."|||"..p.name.." - "..buildTimeString(p)
		end
	end
	resultstring = $.."|||```"
	fileprint(resultstring)
end

addHook("ThinkFrame", function()
	if roundstatus != RS_THINK then
		roundstatus = RS_THINK
	end
end)
addHook("IntermissionThinker", function()
	if roundstatus != RS_INT then
		tryresults()
		roundstatus = RS_INT
	end
end)
addHook("VoteThinker", function()
	if roundstatus != RS_VOTE then
		tryresults()
		roundstatus = RS_VOTE
	end
end)